#include "typedef.h"

/**
 * Print the arc to a stream
 * @param arc BDD represting the arc 
 * @param idmap Map of bdd var nums to ap id:s
 * @param output stream where the arc is printed
 */

void printArc(const class bdd & arc, const AtomMap  &idmap, FILE *output);

/**Function doing the actual printing
 *@param arc The bdd to be printed 
 *@param output Stream where the printing is directed
 *@param idmap Map from bdd variable number to atom 
 *@param bddmap Map for avoiding doubles
 *@param pathcount The number of paths in the bdd arc
 *@param calls Number the function has been called for this arc
 */
void printBDD(const class bdd & arc, FILE* output, const AtomMap &idmap, BddMap &bddmap, 
	      int & pathcount, int calls = 0);

/**Help function for printing one satisfiable assignment
 *@param bddmap Map containing assignment
 *@param output Stream where printing is directed
 */
void printPath(const BddMap &bddmap, FILE* output);

/**
 * Print the arc to a stream in spin format
 * @param arc BDD represting the arc 
 * @param idmap Map of bdd var nums to ap id:s
 * @param output stream where the arc is printed
 */

void 
spinprintArc(const class bdd &arc, const AtomMap &idmap, FILE *output);


