#ifndef TYPEDEF_H_
#define TYPEDEF_H_

#include<vector>
#include "Atom.h"
typedef vector<Atom> AtomMap;
#include "bdd.h"
typedef vector<bdd> IntBddMap;

#include <hash_map>

struct eqstr
{
  bool operator()(const class bdd &s1, const class bdd &s2) const
  {
    return s1 == s2;
  }
};


struct bddhasher
{
  hash<unsigned> H;

  size_t operator()(const class bdd &s1) const
  {  
    return H(s1.id());
  }
};
typedef std::hash_map<class bdd, std::pair<int, bool>, bddhasher, eqstr> BddMap;

static hash<int> H;
struct eqf {
  bool operator()(const class Formula *f1, const class Formula *f2) const {    
    if(f1==f2)
      return true;
    else
      return *f1 == *f2;
  }
};

struct hasher {
  int operator()(const class Formula *f) const {
    return H(f->hash());
  }  
};

typedef std::hash_map<const class Formula *, unsigned, hasher, eqf> FormulaMap;
typedef std::hash_map<const class Formula *, bdd, hasher, eqf> FormulaBddMap; 

#endif //TYPEDEF_H_
