//Class for representing propositional constants true, false -*- c++ -*-
#ifndef CONST_H_
#define CONST_H_
#pragma interface

#include "Formula.h"

class Const : public Formula {
 public:
  /**Construct a new constant
   *@param value Value of the constant
   */
  Const(bool value);
  /**The destructor*/
  ~Const() {; }
  void destroy() {
    delete this;
  }
  /**The copy constructor*/
  Const(const class Const &other);
  /**@return A deep copy of this object*/
  class Const* clone() const {
    return new Const(myValue);
  }
  /**The assignment operator*/
  class Const & operator=(const class Const &other);
  /**@return the value*/
  bool getVal() const {return myValue;}
  /**Print the formula in post-fix order to file*/
  void print(FILE *file) const;
    /**@return The type of formula*/
  enum Formula::Type getType() const { return fConst;} 
  /**@return The hashvalue of the formula*/  
  int hash() const {return myValue ? 2 : 1;}
  /**@return true if the formulas are syntactically equal*/  
  bool operator==(const class Formula &other) const;

 private:
  bool myValue;
};
#endif //CONST_H_
